
stages:
  - gen-pid

services:
  - name: docker:dind

variables:
  PID_GENERATOR: registry.gitlab.com/crossref/labs/static-page-id-generator:mvp
  JOB_COMMIT_MESSAGE: "Adding DOI"
  STATUS_MSG: "No files changed"
  DOIS_GENERATED: 'DOIs Generated'

gen-pid:
  image: docker:stable
  variables:
    GIT_STRATEGY: clone
  stage: gen-pid
  script:
    - |- 
        if [[ "$CI_COMMIT_MESSAGE" != "$JOB_COMMIT_MESSAGE" ]]; then
          apk update
          apk upgrade
          apk add git
          git config user.email "labs@crossref.org"
          git config user.name "gitlab-ci-token"
          git checkout -b $CI_COMMIT_BRANCH
          export dir=`pwd`
          docker pull $PID_GENERATOR
          docker run -v $dir:/static-site-pid-generator/website-repo -e username=$username -e password=$password -e deposit_endpoint=$deposit_endpoint $PID_GENERATOR python run_all.py gen-pid -r website-repo -st crossref --info website-repo/submission_info.yml
          git add -- . ':!xml_submission/*.xml'
          modified_files=`git diff --name-only $CI_COMMIT_BRANCH`

          if [[ "$modified_files" == "" ]]; then
              echo $STATUS_MSG
              echo "PID_CREATED=$STATUS_MSG" > pid_chk.env
          elif [[ "$modified_files" != "" ]]; then
              git commit -m"$JOB_COMMIT_MESSAGE" .
              LAST_COMMIT=`git log -n 1 --pretty=format:"%h" | tail -n 1`
              git push https://gitlab-ci-token:$PUSH_TOKEN@$CI_SERVER_HOST/$CI_PROJECT_PATH.git HEAD:$CI_COMMIT_BRANCH
          fi
          if [[ $LAST_COMMIT != $CI_COMMIT_SHORT_SHA ]]; then
            echo $DOIS_GENERATED
          fi
        else
          echo "Files pushed to the repository"
        fi
  artifacts:
    paths:
      - xml_submission
    expire_in: 1 day















